Cutlass CUDA Templates for Linear Algebra Subroutines and Solvers

Public Types | Public Member Functions | List of all members
cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator Class Reference

Constant iterator over tensors implied by TensorRefBatchStrided.

`#include <tensor_ref_collection.h>`

## Public Types
typedef Base | TensorRef
| TensorRef returned by the iterator. More...

## Public Member Functions
CUTLASS_HOST_DEVICE | ConstIterator (TensorRefBatchStrided const &ref, LongIndex offset=0)
| Constructs a ConstIterator from a parent TensorRefBatchStrided. More...
CUTLASS_HOST_DEVICE TensorRef | operator* () const
| Obtains a TensorRef pointed to by the iterator. More...
CUTLASS_HOST_DEVICE ConstIterator & | operator++ ()
| Advances the iterator to point to the next tensor. More...
CUTLASS_HOST_DEVICE ConstIterator | operator++ (int)
| Advances the iterator to point to the next tensor. More...
CUTLASS_HOST_DEVICE ConstIterator | operator+ (Index idx)
| Returns an iterator advanced by (idx) amount. More...
CUTLASS_HOST_DEVICE ConstIterator & | operator+= (Index idx)
| Advances this iterator by (idx) and returns a reference to self. More...
CUTLASS_HOST_DEVICE ConstIterator & | operator-- ()
| Moves to the previous tensor. More...
CUTLASS_HOST_DEVICE ConstIterator | operator-- (int)
| Moves to the previous tensor. More...
CUTLASS_HOST_DEVICE ConstIterator | operator- (Index idx)
| Returns an iterator moved forward by (idx) amount. More...
CUTLASS_HOST_DEVICE ConstIterator & | operator-= (Index idx)
| Moves this iterator by (idx) and returns a reference to self. More...
CUTLASS_HOST_DEVICE LongIndex | operator- (ConstIterator const &it)
| Returns the difference in offset between two iterators. More...

## Member Typedef Documentation

## ◆ TensorRef

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

typedef Base cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::TensorRef

## Constructor & Destructor Documentation

## ◆ ConstIterator()

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::ConstIterator | ( | TensorRefBatchStrided const & | ref,
|  | LongIndex | offset = `0`
| ) |  |
| inline

## Member Function Documentation

## ◆ operator*()

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE TensorRef cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator* | ( |  | ) | const
| inline

## ◆ operator+()

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE ConstIterator cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator+ | ( | Index | idx | ) |
| inline

## ◆ operator++() [1/2]

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE ConstIterator& cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator++ | ( |  | ) |
| inline

## ◆ operator++() [2/2]

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE ConstIterator cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator++ | ( | int |  | ) |
| inline

## ◆ operator+=()

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE ConstIterator& cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator+= | ( | Index | idx | ) |
| inline

## ◆ operator-() [1/2]

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE ConstIterator cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator- | ( | Index | idx | ) |
| inline

## ◆ operator-() [2/2]

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE LongIndex cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator- | ( | ConstIterator const & | it | ) |
| inline

## ◆ operator--() [1/2]

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE ConstIterator& cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator-- | ( |  | ) |
| inline

## ◆ operator--() [2/2]

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE ConstIterator cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator-- | ( | int |  | ) |
| inline

## ◆ operator-=()

template<typename Storage_ , int Rank_, typename MapFunc_ = IdentityTensorMapFunc<Rank_>, int StorageRank_ = MapFunc_::kStorageRank, typename Index_ = int, typename LongIndex_ = long long>

CUTLASS_HOST_DEVICE ConstIterator& cutlass::TensorRefBatchStrided< Storage_, Rank_, MapFunc_, StorageRank_, Index_, LongIndex_ >::ConstIterator::operator-= | ( | Index | idx | ) |
| inline

The documentation for this class was generated from the following file:

- tensor_ref_collection.h